local N_OF_ITEMS = 11

local function LeftRightArrowsInput()
	return AND(GetInput(), 0x1000000) ~= 0 or AND(GetInput(), 0x2000000) ~= 0
end

local function JumpAttackInput()
	return AND(GetInput(), 2) ~= 0 or AND(GetInput(), 1) ~= 0
end

local function NewRespawnPoint(x,y)
    snRes(x, 11, 17)
    snRes(y, 11, 18)
end

local function CreateItemImage(PosX, PosY, number)
    local _images = {
        "CUSTOM_ARTIFACTS_AMULET",
        "CUSTOM_ARTIFACTS_FIRESHIELD",
        "CUSTOM_ARTIFACTS_HEALINGSCROLL",
        "CUSTOM_ARTIFACTS_MAGICBAG",
        "CUSTOM_ARTIFACTS_MAGICRING",
        "CUSTOM_ARTIFACTS_PIERCINGBULLETSBAG",
        "CUSTOM_ARTIFACTS_POWERRING",
        "CUSTOM_ARTIFACTS_WINGS",
        "CUSTOM_ARTIFACTS_FIREESSENCE",
        "CUSTOM_ARTIFACTS_ARCANEGEM",
        "CUSTOM_ARTIFACTS_AETHER"
    }
	return CreateObject{x=PosX, y=PosY, z=11002, logic="AniCycle", image=_images[number]}
end

local function CheckForRepetition(listOfItems, theNewItem)
	for _,previousItem in pairs(listOfItems) do
		if theNewItem == previousItem then
			return true
		end
	end
	return false
end

local function Lotery(previousResult)
	local listOfItems = DetectorHook.ListOfAlreadyChosen
	if previousResult ~= 0 then table.insert(listOfItems, previousResult) end
	repeat
		theNewItem = math.random(N_OF_ITEMS)
		itemExists = CheckForRepetition(listOfItems, theNewItem)
	until itemExists == false
	return theNewItem
end


function main(self)

local Box1X = GetClaw().X - 64
local Box2X = GetClaw().X + 64
local BoxY = GetClaw().Y - 160
local PaperY = GetClaw().Y + 16
local NoteY = GetClaw().Y + 180
DetectorHook = GetObject(3206)

    if self.State == 0 then
		self.ItemSelectNo = 1
		self.LanguageSelectNo = 0
		self.DrawFlags.NoDraw = true
		self.EnterPressBuffer = false
		self.State = 1
	end


	-- Prepare for language selection:
	if self.State == 1 and GetClaw().X > self.XMin and GetClaw().X < self.XMax and GetClaw().Y > self.YMin and GetClaw().Y < self.YMax then

		if self.LanguageSelectNo == 0 and (GetClaw().State == 24 or GetClaw().State == 8 or GetClaw().State == 9) then
			PlaySound("GAME_PURELEASE1")
			GetClaw():SetAnimation("CLAW_STAND", 100)
			GetClaw().State = 5009
			NewRespawnPoint(GetClaw().X, GetClaw().Y)
			self.Background = CreateObject{x=GetClaw().X,y=GetClaw().Y,z=10800,logic="DoNothingNormal",image="CUSTOM_SELECT_SCREEN"}
			self.LanguageSelectNo = 1
		end

		if self.LanguageSelectNo == 1 then
			if not DetectorHook.Language then 
				self.LanguageSelectNo = 2
			else
				self.State = 4
			end
		end

		if self.LanguageSelectNo == 2 then
			self.LangBox1 = CreateObject{x=Box1X,y=PaperY,z=11001,logic="DoNothing",image="CUSTOM_SELECT_BOXF_SELECTED"}
			self.LangBox2 = CreateObject{x=Box2X,y=PaperY,z=11001,logic="DoNothing",image="CUSTOM_SELECT_BOXF_NOT"}
			self.LangFlag1 = CreateObject{x=Box1X,y=PaperY,z=11002,logic="DoNothing",image="CUSTOM_SELECT_FLAGS_ENG"}
			self.LangFlag2 = CreateObject{x=Box2X,y=PaperY,z=11002,logic="DoNothing",image="CUSTOM_SELECT_FLAGS_PL"}
			self.SelectTimeDelay = GetTime() + 300
			self.State = 2
		end

		if self.LanguageSelectNo == 404 then
			self:Destroy()
		end

	end

    
	-- Language selection:
	if self.State == 2 then

		if LeftRightArrowsInput() == true and GetTime() > self.SelectTimeDelay then
			if GetImgStr(self.LangBox1.Image) == "CUSTOM_SELECT_BOXF_SELECTED" then
				self.LangBox1:SetImage("CUSTOM_SELECT_BOXF_NOT")
				self.LangBox2:SetImage("CUSTOM_SELECT_BOXF_SELECTED")
			elseif GetImgStr(self.LangBox1.Image) == "CUSTOM_SELECT_BOXF_NOT" then
				self.LangBox1:SetImage("CUSTOM_SELECT_BOXF_SELECTED")
				self.LangBox2:SetImage("CUSTOM_SELECT_BOXF_NOT")
			end
			PlaySound("GAME_CLICK")
			self.SelectTimeDelay = GetTime() + 200
		end

		-- Key press fix:
		if self.EnterPressBuffer == false and JumpAttackInput() == false then
			self.EnterPressBuffer = true
		end

		-- Confirm choice:
		if JumpAttackInput() == true and GetTime() > self.SelectTimeDelay and self.EnterPressBuffer == true then
			PlaySound("GAME_SELECT")
			self.LangChoice = false
			self.State = 3
		end

		-- Freeze Claw again, if sth unexpected happen:
		if GetClaw().State ~= 5009 and GetClaw().State ~= 5004 then
			GetClaw().State = 5009
		end

	end


	-- Save language:
	if self.State == 3 then

		if self.LangChoice == false then
			if GetImgStr(self.LangBox1.Image) == "CUSTOM_SELECT_BOXF_SELECTED" then
				DetectorHook.Language = "English"
				self.LangChoice = true
			elseif GetImgStr(self.LangBox2.Image) == "CUSTOM_SELECT_BOXF_SELECTED" then
				DetectorHook.Language = "Polish"
				self.LangChoice = true
			end
		end

		if self.LangChoice == true then
			self.LangBox1:Destroy()
			self.LangBox2:Destroy()
			self.LangFlag1:Destroy()
			self.LangFlag2:Destroy()
			self.State = 4
		end

	end


	-- Prepare for artifact selection, draw artifacts:
	if self.State == 4 then 

		if self.ItemSelectNo == 1 then
			if DetectorHook.Language == "English" then
				self.SpecialNote = CreateObject{x=GetClaw().X,y=NoteY,z=11001,logic="DoNothingNormal",image="CUSTOM_SELECT_SPECIAL_ENG"}
				self.Paper = CreateObject{x=GetClaw().X,y=PaperY,z=11001,logic="DoNothingNormal",image="CUSTOM_SELECT_PAPER_ENG"}
			elseif DetectorHook.Language == "Polish" then
				self.SpecialNote = CreateObject{x=GetClaw().X,y=NoteY,z=11001,logic="DoNothingNormal",image="CUSTOM_SELECT_SPECIAL_PL"}
				self.Paper = CreateObject{x=GetClaw().X,y=PaperY,z=11001,logic="DoNothingNormal",image="CUSTOM_SELECT_PAPER_PL"}
			end
			self.Box1 = CreateObject{x=Box1X,y=BoxY,z=11001,logic="DoNothing",image="CUSTOM_SELECT_BOX_SELECTED"}
			self.Box2 = CreateObject{x=Box2X,y=BoxY,z=11001,logic="DoNothing",image="CUSTOM_SELECT_BOX_NOT"}
			self.Lotery1 = Lotery(0)
			self.ItemSelectNo = 2
		end

		if self.ItemSelectNo == 2 then
			self.Item1 = CreateItemImage(Box1X, BoxY, self.Lotery1)
			self.Paper:SetFrame(self.Lotery1)
			self.Lotery2 = Lotery(self.Lotery1)
			self.ItemSelectNo = 3
		end

		if self.ItemSelectNo == 3 then
			self.Item2 = CreateItemImage(Box2X, BoxY, self.Lotery2)
			if self.Lotery1 == 2 or self.Lotery1 == 4 or self.Lotery1 == 10 then 
				self.SpecialNote:SetFrame(2) 
			else 
				self.SpecialNote:SetFrame(1) 
			end
			self.SelectTimeDelay = GetTime() + 500
			self.EnterPressBuffer = false
			self.ItemSelectNo = 4
		end

		if self.ItemSelectNo == 4 and GetTime() > self.SelectTimeDelay then
			self.State = 5
		end

	end

	-- Artifact selection:
	if self.State == 5 then 
		if LeftRightArrowsInput() == true and GetTime() > self.SelectTimeDelay then
			if self.Paper.I == self.Lotery1 then
				self.Box1:SetImage("CUSTOM_SELECT_BOX_NOT")
				self.Box2:SetImage("CUSTOM_SELECT_BOX_SELECTED")
				self.Paper:SetFrame(self.Lotery2)
				if self.Lotery2 == 2 or self.Lotery2 == 4 or self.Lotery2 == 10 then 
					self.SpecialNote:SetFrame(2) 
				else 
					self.SpecialNote:SetFrame(1) 
				end
			elseif self.Paper.I == self.Lotery2 then
				self.Box1:SetImage("CUSTOM_SELECT_BOX_SELECTED")
				self.Box2:SetImage("CUSTOM_SELECT_BOX_NOT")
				self.Paper:SetFrame(self.Lotery1)
				if self.Lotery1 == 2 or self.Lotery1 == 4 or self.Lotery1 == 10 then 
					self.SpecialNote:SetFrame(2) 
				else 
					self.SpecialNote:SetFrame(1) 
				end
			end
			PlaySound("GAME_CLICK")
			self.SelectTimeDelay = GetTime() + 200
		end
		-- Freeze Claw again, if sth unexpected happen:
		if GetClaw().State ~= 5009 and GetClaw().State ~= 5004 then
			GetClaw().State = 5009
		end
		-- Key press fix:
		if self.EnterPressBuffer == false and JumpAttackInput() == false then
			self.EnterPressBuffer = true
		end
		-- Confirm choice:
		if JumpAttackInput() == true and self.EnterPressBuffer == true then
			PlaySound("GAME_SELECT")
			self.State = 6
		end
	end

	-- Save selected item in the internal variable:
	if self.State == 6 then
		self.SpawnItem = self.Paper.I
		self.State = 7
	end

	-- Destroy the selection menu, unfreeze Claw:
	if self.State == 7 then
		self.Paper:Destroy()
		self.Box1:Destroy()
		self.Box2:Destroy()
		self.Item1:Destroy()
		self.Item2:Destroy()
		self.Background:Destroy()
		self.SpecialNote:Destroy()
		if GetClaw().State ~= 5004 then GetClaw().State = 24 end
		self.SelectTimeDelay = GetTime() + 500
		self.State = 8
	end

	-- Save selected item in the external list and create item spawner:
	if self.State == 8 and GetTime() > self.SelectTimeDelay then
		if self.SpawnItem == 2 or self.SpawnItem == 4 or self.SpawnItem == 10 then
			table.insert(DetectorHook.ListOfAlreadyChosen, 2)
			table.insert(DetectorHook.ListOfAlreadyChosen, 4)
			table.insert(DetectorHook.ListOfAlreadyChosen, 10)
		else
			table.insert(DetectorHook.ListOfAlreadyChosen, self.SpawnItem)
		end
		CreateObject{x=self.SpeedX,y=self.SpeedY,z=4000,logic="CustomLogic",name="ArtifactSpawner",Counter=self.SpawnItem}
		self.State = 9
	end

	-- Destroy:
	if self.State == 9 then
		self.LanguageSelectNo = 404
		self.State = 1
	end
	
end
