local function HealClawEffect()
	local claw = GetClaw()
	local randomX = claw.X + claw.MoveRect.Left + math.random(math.abs(claw.MoveRect.Left-claw.MoveRect.Right))
	local randomY = claw.Y + claw.HitRect.Top + math.random(math.abs(claw.HitRect.Top-claw.HitRect.Bottom))
	CreateObject{x=randomX, y=randomY, z=claw.Z+1, logic="CustomLogic", name="PowerOfHealingScrollEffect"}
end

function main(self)
    if self.State == 0 then
		self.Flags.AlwaysActive, self.DrawFlags.NoDraw = true, true
		self.Cooldown = 25000
		self.SoundDelay = 0
		self.TimeCounter = 0
		self.State = 1
	end
	-- Count cooldown and monitor Claw's health before activation:
	if self.State == 1 then
		if GetTime() > self.TimeCounter and GetClaw().Health < 120 and GetClaw().Health > 0 then
			self.State = 2
		end
	end
	-- Healing in work:
	if self.State == 2 then
		if GetClaw().Health >= 110 then
			GetClaw().Health = 120
			self.TimeCounter = GetTime() + self.Cooldown
			self.State = 3
		elseif GetClaw().Health < 110 and GetClaw().Health > 0 then
			GetClaw().Health = math.floor(GetClaw().Health+10)
			self.TimeCounter = GetTime() + self.Cooldown
			self.State = 3
		elseif GetClaw().Health <= 0 then
			self.TimeCounter = GetTime() + self.Cooldown/5
			self.State = 1
		end
	end
	-- Healing effect:
	if self.State == 3 then
		-- Show healing effect only if catnip isn't active:
		if _CurrentPowerup[0] ~= 9916 then HealClawEffect() end
		-- Stop the effect after 1/20 of cooldown and go back to State 1:
		if GetTime() > self.TimeCounter - 19*self.Cooldown/20 then
			self.State = 1
		end
	end
end



