local SaveFilePath = "Custom/Arcana v1.2/save.txt"

local function NewRespawnPoint(x, y)
    snRes(x, 11, 17) 
    snRes(y, 11, 18)
end

local function GetStatsTable(self)
	local saveFile = io.open(SaveFilePath, "r")
	local line = {}
	line[0] = saveFile:read("*l")
	line[1] = saveFile:read("*l")
	line[2] = saveFile:read("*l")
	line[3] = saveFile:read("*l")
	self.Stats = {}
	for stat in string.gmatch(line[self.Smarts], "[^;]+") do
		table.insert(self.Stats, tonumber(stat))
	end
	io.close(saveFile)
end

local function SpawnArtifactsPower(items)

	DetectorHook.ArtifactsOwned = items

    local _names = {
        "PowerOfAmuletOfNineLives",
        "PowerOfFireShield",
        "PowerOfHealingScroll",
        "PowerOfHeavenlyBag",
        "PowerOfMagicRing",
        "PowerOfPiercingBullets",
        "PowerOfPowerRing",
        "PowerOfMercifulWings",
        "PowerOfFireEssence",
        "PowerOfArcaneGem",
        "PowerOfAether"
    }
    local art = 0
    repeat
        if AND(items, 2^art) ~= 0 then 
		    CreateObject{x=GetClaw().X, y=GetClaw().Y, z=0, logic="CustomLogic", name=_names[math.log(2^art)/math.log(2) + 1]} 
            if art+1 == 2 or art+1 == 4 or art+1 == 10 then
		        table.insert(DetectorHook.ListOfAlreadyChosen, 2)
                table.insert(DetectorHook.ListOfAlreadyChosen, 4)
                table.insert(DetectorHook.ListOfAlreadyChosen, 10)
            else
                table.insert(DetectorHook.ListOfAlreadyChosen, art+1)
            end
	    end
        art = art + 1
    until art > 11

end

local function SetDiffAndRes(dif, res)
	DetectorHook.Difficulty = dif
	DetectorHook.Resolution = res
	CreateObject{x=GetClaw().X, y=GetClaw().Y, z=0, logic="CustomLogic", name="ResChanger", Smarts=res}
	CreateObject{x=GetClaw().X, y=GetClaw().Y, z=0, logic="CustomLogic", name="ModeDisplay", Smarts=dif, Width=res}
	if dif == 2 then
		CreateObject{x=GetClaw().X,y=GetClaw().Y,z=0,logic="CustomLogic",name="HardcoreMode"}	
	elseif dif == 1 then
		CreateObject{x=GetClaw().X,y=GetClaw().Y,z=0,logic="CustomLogic",name="EasyMode"}
	end
end

function main(self)

	DetectorHook = GetObject(3206)
	
    if self.State == 0 then
        self.AttackRect = {-24,-24,24,24}
        self.AttackTypeFlags = ObjectType.Player
		self.Flags.AlwaysActive = true
		GetStatsTable(self)
		self.State = 1
    end
	
	if self.State == 1 then self.State = 2 end
	if self.State == 2 then self.State = 1 end
	
	if self.State == 499 and GetTime() > self.CountTime then
		SpawnArtifactsPower(self.Stats[16])
        PlayerData().Lives = self.Stats[14]
		self.State = 500
	end
	if self.State == 500 then self:Destroy() end
end

function attack(self)

	SetDiffAndRes(self.Stats[17], self.Stats[18])

	PlayerData()._unkns[TreasureType.Skull - 1] = self.Stats[1]
	PlayerData()._unkns[TreasureType.Crown - 1] = self.Stats[2]
	PlayerData()._unkns[TreasureType.Gecko - 1] = self.Stats[3]
	PlayerData()._unkns[TreasureType.Scepter - 1] = self.Stats[4]
	PlayerData()._unkns[TreasureType.Cross - 1] = self.Stats[5]
	PlayerData()._unkns[TreasureType.Chalice - 1] = self.Stats[6]
	PlayerData()._unkns[TreasureType.Ring - 1] = self.Stats[7]
	PlayerData()._unkns[TreasureType.Goldbar - 1] = self.Stats[8]
	PlayerData()._unkns[TreasureType.Coin - 1] = self.Stats[9]

    PlayerData().Lives = 10 -- temporarly set lives to max, so increasing the score won't trigger the sound

	GetClaw().Score = self.Stats[10]
	PlayerData().PistolAmmo = self.Stats[11]
	PlayerData().MagicAmmo = self.Stats[12]
	PlayerData().TNTAmmo = self.Stats[13]
	GetClaw().Health = self.Stats[15]
	
	NewRespawnPoint(self.SpeedX, self.SpeedY)
	local GoldFlag = GetObject(self.Counter)
	GoldFlag.DrawFlags.NoDraw = true
	GoldFlag.Y = 50
	Teleport(self.SpeedX, self.SpeedY)
	ClawJump(0)

	self.CountTime = GetTime() + 640
	self.State = 499
end
