local LevelStartX = 2450
local LevelStartY = 3750
local SaveFilePath = "Custom/Arcana v1.2/save.txt"

local function NewRespawnPoint(posx, posy)
	ffi.cast("int*", _nResult[0][11])[17] = posx
	ffi.cast("int*", _nResult[0][11])[18] = posy
end

local function UpArrowInput()
	if AND(GetInput(), 0x4000000) ~= 0 then
		return true
	else return false end
end

local function DownArrowInput()
	if AND(GetInput(), 0x8000000) ~= 0 then
		return true
	else return false end
end

local function LeftArrowInput()
	if AND(GetInput(), 0x1000000) ~= 0 then
		return true
	else return false end
end

local function RightArrowInput()
	if AND(GetInput(), 0x2000000) ~= 0 then
		return true
	else return false end
end

local function EnterInput()
	if AND(GetInput(), 2) ~= 0 or AND(GetInput(), 1) ~= 0 or KeyPressed(0x0D) then
		return true
	else return false end
end

local function ChangeBallsPosition(self, a, ai, b, bi, c, ci, d, di, e, ei, f, fi)
	if a.I == ai then
		self.IceBall.Y, self.FireBall.Y = a.Y, a.Y
	end
	if b then
		if b.I == bi then
			self.IceBall.Y, self.FireBall.Y = b.Y, b.Y
		end
	end
	if c then
		if c.I == ci then
			self.IceBall.Y, self.FireBall.Y = c.Y, c.Y
		end
	end
	if d then
		if d.I == di then
			self.IceBall.Y, self.FireBall.Y = d.Y, d.Y
		end
	end
	if e then
		if e.I == ei then
			self.IceBall.Y, self.FireBall.Y = e.Y, e.Y
		end
	end
	if f then
		if f.I == fi then
			self.IceBall.Y, self.FireBall.Y = f.Y, f.Y
		end
	end
end

function main(self)

	DetectorHook = GetObject(3206)
	
	if self.State == 0 then
		self.BeginNo = 1
        self.Flags.AlwaysActive = true
		self.KeyPressDelay = 0
		self.State = 1
	end
	-- Freeze Claw:
	if self.State == 1 then
		GetClaw().State = 5009
		self.MainChoice = { }
		self.LoadChoice = { }
		self.State = 2
	end
	-- Create all menu elements:
	if self.State == 2 then
		if self.BeginNo == 1 then
			self.Title = CreateObject{x=GetClaw().X,y=GetClaw().Y-120,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_TITLES"}
			self.IceBall = CreateObject{x=GetClaw().X-300,y=GetClaw().Y-80,z=11011,logic="AniCycle",image="CUSTOM_ICESHIELD"}
			self.IceBall:SetAnimation("CUSTOM_CYCLE72")
			self.FireBall = CreateObject{x=GetClaw().X+300,y=GetClaw().Y-80,z=11011,logic="AniCycle",image="CUSTOM_FIRESHIELD"}
			self.FireBall:SetAnimation("CUSTOM_CYCLE72")
			self.MainChoice[1] = CreateObject{x=GetClaw().X,y=GetClaw().Y-80,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_START"}
			self.MainChoice[2] = CreateObject{x=GetClaw().X,y=GetClaw().Y-40,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_LOAD"}
			self.MainChoice[3] = CreateObject{x=GetClaw().X,y=GetClaw().Y,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_ASPECTRATIO"}
			self.MainChoice[4] = CreateObject{x=GetClaw().X,y=GetClaw().Y+40,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_HELP"}
			self.MainChoice[5] = CreateObject{x=GetClaw().X,y=GetClaw().Y+80,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_CREDITS"}
			self.Easy = CreateObject{x=GetClaw().X,y=GetClaw().Y-60,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_EASY"}
			self.Normal = CreateObject{x=GetClaw().X,y=GetClaw().Y-20,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_NORMAL"}
			self.Hardcore = CreateObject{x=GetClaw().X,y=GetClaw().Y+20,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_HARDCORE"}
			self.LoadChoice[1] = CreateObject{x=GetClaw().X,y=GetClaw().Y-60,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_SAVE1"}
			self.LoadChoice[2] = CreateObject{x=GetClaw().X,y=GetClaw().Y-20,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_SAVE2"}
			self.LoadChoice[3] = CreateObject{x=GetClaw().X,y=GetClaw().Y+20,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_BOSS"}
			self.BackChoice = CreateObject{x=GetClaw().X,y=GetClaw().Y+60,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_BACK"}
			self.HelpScreen = CreateObject{x=GetClaw().X,y=GetClaw().Y-40,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_HELP_SCREEN"}
			self.CreditsScreen = CreateObject{x=GetClaw().X,y=GetClaw().Y-40,z=11011,logic="DoNothingNormal",image="CUSTOM_STARTMENU_CREDITS_SCREEN"}
			self.BeginNo = 2
		end
		-- Prepare to display main menu:
		if self.BeginNo == 2 then
			if GetGameType() ~= GameType.MultiPlayer then
				local SaveFile = io.open(SaveFilePath, "r")
				if SaveFile ~= nil then
					local SavedFlags = tonumber(SaveFile:read("*line"))
					if AND(SavedFlags, 0x10) ~= 0 then
						self.LoadChoice[1]:SetFrame(2)
					end
					if AND(SavedFlags, 0x20) ~= 0 then
						self.LoadChoice[2]:SetFrame(2)
					end
					if AND(SavedFlags, 0x40) ~= 0 then
						self.LoadChoice[3]:SetFrame(2)
					end
					io.close(SaveFile)
				end
			end
			for _,choice in ipairs(self.LoadChoice) do
				choice.DrawFlags.NoDraw = true
			end
			self.BackChoice.DrawFlags.NoDraw = true
			self.HelpScreen.DrawFlags.NoDraw = true
			self.CreditsScreen.DrawFlags.NoDraw = true
			self.Easy.DrawFlags.NoDraw = true
			self.Normal.DrawFlags.NoDraw = true
			self.Hardcore.DrawFlags.NoDraw = true
			self.Title.DrawFlags.NoDraw = true
			self.MainChoice[1]:SetFrame(2)
			self.KeyPressDelay = GetTime() + 500
			self.State = 3
		end
	end
	-- Enter press fix:
	if self.State == 3 and EnterInput() == false then
		self.State = 4
	end
	-- Main menu:
	if self.State == 4 and GetTime() > self.KeyPressDelay then	
		if DownArrowInput() == true then
			PlaySound("GAME_CLICK")
			self.KeyPressDelay = GetTime() + 150
			if self.MainChoice[1].I == 2 then
				self.MainChoice[1]:SetFrame(1)
				self.MainChoice[2]:SetFrame(2)
			elseif self.MainChoice[2].I == 2 then
				self.MainChoice[2]:SetFrame(1)
				if self.MainChoice[3].I == 1 then
					self.MainChoice[3]:SetFrame(2)
				elseif self.MainChoice[3].I == 3 then
					self.MainChoice[3]:SetFrame(4)
				end
			elseif self.MainChoice[3].I == 2 then
				self.MainChoice[3]:SetFrame(1)
				self.MainChoice[4]:SetFrame(2)
			elseif self.MainChoice[3].I == 4 then
				self.MainChoice[3]:SetFrame(3)
				self.MainChoice[4]:SetFrame(2)
			elseif self.MainChoice[4].I == 2 then
				self.MainChoice[4]:SetFrame(1)
				self.MainChoice[5]:SetFrame(2)
			elseif self.MainChoice[5].I == 2 then
				self.MainChoice[5]:SetFrame(1)
				self.MainChoice[1]:SetFrame(2)	
			end
		end
		if UpArrowInput() == true then
			PlaySound("GAME_CLICK")
			self.KeyPressDelay = GetTime() + 150
			if self.MainChoice[5].I == 2 then
				self.MainChoice[5]:SetFrame(1)
				self.MainChoice[4]:SetFrame(2)
			elseif self.MainChoice[4].I == 2 then
				self.MainChoice[4]:SetFrame(1)
				if self.MainChoice[3].I == 1 then
					self.MainChoice[3]:SetFrame(2)
				elseif self.MainChoice[3].I == 3 then
					self.MainChoice[3]:SetFrame(4)
				end
			elseif self.MainChoice[3].I == 2 then
				self.MainChoice[3]:SetFrame(1)
				self.MainChoice[2]:SetFrame(2)
			elseif self.MainChoice[3].I == 4 then
				self.MainChoice[3]:SetFrame(3)
				self.MainChoice[2]:SetFrame(2)
			elseif self.MainChoice[2].I == 2 then
				self.MainChoice[2]:SetFrame(1)
				self.MainChoice[1]:SetFrame(2)
			elseif self.MainChoice[1].I == 2 then
				self.MainChoice[1]:SetFrame(1)
				self.MainChoice[5]:SetFrame(2)
			end
		end
		ChangeBallsPosition(self, self.MainChoice[1], 2, self.MainChoice[2], 2, self.MainChoice[3], 2, self.MainChoice[4], 2, self.MainChoice[5], 2, self.MainChoice[3], 4)
		if EnterInput() == true then
			PlaySound("GAME_SELECT")
			self.KeyPressDelay = GetTime() + 200
			if self.MainChoice[1].I == 2 then
				self.State = 99
			elseif self.MainChoice[2].I == 2 then
				self.State = 199
			elseif self.MainChoice[3].I == 2 then
				self.MainChoice[3]:SetFrame(4)
			elseif self.MainChoice[3].I == 4 then
				self.MainChoice[3]:SetFrame(2)
			elseif self.MainChoice[4].I == 2 then
				self.State = 399
			elseif self.MainChoice[5].I == 2 then
				self.State = 499
			end
			if self.MainChoice[3].I == 1 or self.MainChoice[3].I == 3 then
				for _,mainchoice in ipairs(self.MainChoice) do
					mainchoice.DrawFlags.NoDraw = true
				end
			end
		end
	end
	
	
	-- Start - choose difficulty:
	if self.State == 99 then
		self.Easy.DrawFlags.NoDraw = false
		self.Normal.DrawFlags.NoDraw = false
		self.Hardcore.DrawFlags.NoDraw = false
		self.BackChoice.DrawFlags.NoDraw = false
		self.Title.DrawFlags.NoDraw = false
		self.Normal:SetFrame(2)
		ChangeBallsPosition(self, self.Normal, 2)
		self.Title:SetFrame(1)
		self.State = 100
	end
	-- Enter press fix:
	if self.State == 100 and EnterInput() == false then
		self.State = 101
	end
	-- Choose difficulty:
	if self.State == 101  and GetTime() > self.KeyPressDelay then
		if DownArrowInput() == true then
			PlaySound("GAME_CLICK")
			self.KeyPressDelay = GetTime() + 200
			if self.Normal.I == 2 then
				self.Normal:SetFrame(1)
				self.Hardcore:SetFrame(2)
			elseif self.Hardcore.I == 2 then
				self.Hardcore:SetFrame(1)
				self.BackChoice:SetFrame(2)
			elseif self.BackChoice.I == 2 then
				self.BackChoice:SetFrame(1)
				self.Easy:SetFrame(2)
			elseif self.Easy.I == 2 then
				self.Easy:SetFrame(1)
				self.Normal:SetFrame(2)
			end
		end
		if UpArrowInput() == true then
			PlaySound("GAME_CLICK")
			self.KeyPressDelay = GetTime() + 150
			if self.BackChoice.I == 2 then
				self.BackChoice:SetFrame(1)
				self.Hardcore:SetFrame(2)
			elseif self.Hardcore.I == 2 then
				self.Hardcore:SetFrame(1)
				self.Normal:SetFrame(2)
			elseif self.Normal.I == 2 then
				self.Normal:SetFrame(1)
				self.Easy:SetFrame(2)
			elseif self.Easy.I == 2 then
				self.Easy:SetFrame(1)
				self.BackChoice:SetFrame(2)
			end
		end
		ChangeBallsPosition(self, self.Easy, 2, self.Normal, 2, self.Hardcore, 2, self.BackChoice, 2)
		if EnterInput() == true then
			PlaySound("GAME_SELECT")
			self.Easy.DrawFlags.NoDraw = true
			self.Normal.DrawFlags.NoDraw = true
			self.Hardcore.DrawFlags.NoDraw = true
			self.BackChoice.DrawFlags.NoDraw = true
			self.Title.DrawFlags.NoDraw = true
			if self.BackChoice.I == 2 then
				self.KeyPressDelay = GetTime() + 150
				self.BackChoice:SetFrame(1)
				ChangeBallsPosition(self, self.MainChoice[1], 2)
				for _,mainchoice in ipairs(self.MainChoice) do
					mainchoice.DrawFlags.NoDraw = false
				end
				self.State = 3
			elseif self.Easy.I == 2 then
				self.State = 102
			elseif self.Normal.I == 2 then
				self.State = 103
			elseif self.Hardcore.I == 2 then
				self.State = 104
			end
		end
	end
	-- Easy chosen:
	if self.State == 102 then
		CreateObject{x=GetClaw().X,y=GetClaw().Y,z=0,logic="CustomLogic",name="EasyMode"}
		DetectorHook.Difficulty = 1
		self.State = 140
	end
	-- Normal chosen:
	if self.State == 103 then
		DetectorHook.Difficulty = 0
		self.State = 140
	end
	-- Hardcore chosen:
	if self.State == 104 then
		CreateObject{x=GetClaw().X,y=GetClaw().Y,z=0,logic="CustomLogic",name="HardcoreMode"}
		DetectorHook.Difficulty = 2
		self.State = 140
	end
	-- Game start:
	if self.State == 140 then
		if self.MainChoice[3].I > 2 then -- ratio 4:3
			CreateObject{x=GetClaw().X, y=GetClaw().Y, z=0, logic="CustomLogic", name="ResChanger", Smarts=1}
			CreateObject{x=GetClaw().X, y=GetClaw().Y, z=0, logic="CustomLogic", name="ModeDisplay", Smarts=DetectorHook.Difficulty, Width=1}
		else	-- ratio 16:9
			CreateObject{x=GetClaw().X, y=GetClaw().Y, z=0, logic="CustomLogic", name="ResChanger", Smarts=0}
			CreateObject{x=GetClaw().X, y=GetClaw().Y, z=0, logic="CustomLogic", name="ModeDisplay", Smarts=DetectorHook.Difficulty, Width=0}
		end
		Teleport(LevelStartX, LevelStartY)
		NewRespawnPoint(LevelStartX, LevelStartY)
		self.State = 600
	end
	
	
	-- Load game:
	if self.State == 199 then
		for _,loadchoice in ipairs(self.LoadChoice) do
			loadchoice.DrawFlags.NoDraw = false
		end
		self.BackChoice.DrawFlags.NoDraw = false
		self.Title.DrawFlags.NoDraw = false
		self.Title:SetFrame(2)
		if self.LoadChoice[1].I ~= 1 then
			self.LoadChoice[1]:SetFrame(3)
			ChangeBallsPosition(self, self.LoadChoice[1], 3)
		else
			self.BackChoice:SetFrame(2)
			ChangeBallsPosition(self, self.BackChoice, 2)
		end
		self.State = 200
	end
	-- Enter press fix:
	if self.State == 200 and EnterInput() == false then
		if self.LoadChoice[1].I == 3 then
			self.State = 202
		else
			self.State = 201
		end
	end
	-- Load game (no saves):
	if self.State == 201 and GetTime() > self.KeyPressDelay then
		if EnterInput() == true then
			for _,loadchoice in ipairs(self.LoadChoice) do
				loadchoice.DrawFlags.NoDraw = true
			end
			self.BackChoice.DrawFlags.NoDraw = true
			for _,mainchoice in ipairs(self.MainChoice) do
				mainchoice.DrawFlags.NoDraw = false
			end
			ChangeBallsPosition(self, self.MainChoice[1], 2)
			self.Title.DrawFlags.NoDraw = true
			self.BackChoice:SetFrame(1)
			self.KeyPressDelay = GetTime() + 150
			PlaySound("GAME_SELECT")
			self.State = 3
		end
	end
	-- Load game (at least one save):
	if self.State == 202 and GetTime() > self.KeyPressDelay then
		if DownArrowInput() == true then
			PlaySound("GAME_CLICK")
			self.KeyPressDelay = GetTime() + 150
			if self.LoadChoice[1].I == 3 then
				self.LoadChoice[1]:SetFrame(2)
				if self.LoadChoice[2].I ~= 1 then
					self.LoadChoice[2]:SetFrame(3)
				elseif self.LoadChoice[3].I ~= 1 then
					self.LoadChoice[3]:SetFrame(3)
				else
					self.BackChoice:SetFrame(2)
				end
			elseif self.LoadChoice[2].I == 3 then
				self.LoadChoice[2]:SetFrame(2)
				if self.LoadChoice[3].I ~= 1 then
					self.LoadChoice[3]:SetFrame(3)
				else
					self.BackChoice:SetFrame(2)
				end
			elseif self.LoadChoice[3].I == 3 then
				self.LoadChoice[3]:SetFrame(2)
				self.BackChoice:SetFrame(2)
			elseif self.BackChoice.I == 2 then
				self.BackChoice:SetFrame(1)
				if self.LoadChoice[1].I ~= 1 then
					self.LoadChoice[1]:SetFrame(3)
				elseif self.LoadChoice[2].I ~= 1 then
					self.LoadChoice[2]:SetFrame(3)
				else
					self.LoadChoice[3]:SetFrame(3)
				end
			end
		end
		if UpArrowInput() == true then
			PlaySound("GAME_CLICK")
			self.KeyPressDelay = GetTime() + 150
			if self.LoadChoice[1].I == 3 then
				self.LoadChoice[1]:SetFrame(2)
				self.BackChoice:SetFrame(2)
			elseif self.BackChoice.I == 2 then
				self.BackChoice:SetFrame(1)
				if self.LoadChoice[3].I ~= 1 then
					self.LoadChoice[3]:SetFrame(3)
				elseif self.LoadChoice[2].I ~= 1 then
					self.LoadChoice[2]:SetFrame(3)
				elseif self.LoadChoice[1].I ~= 1 then
					self.LoadChoice[1]:SetFrame(3)
				end
			elseif self.LoadChoice[3].I == 3 then
				self.LoadChoice[3]:SetFrame(2)
				if self.LoadChoice[2].I ~= 1 then
					self.LoadChoice[2]:SetFrame(3)
				elseif self.LoadChoice[1].I ~= 1 then
					self.LoadChoice[1]:SetFrame(3)
				else
					self.BackChoice:SetFrame(2)
				end
			elseif self.LoadChoice[2].I == 3 then
				self.LoadChoice[2]:SetFrame(2)
				if self.LoadChoice[1].I ~= 1 then
					self.LoadChoice[1]:SetFrame(3)
				else
					self.BackChoice:SetFrame(2)
				end
			end
		end 
		ChangeBallsPosition(self, self.LoadChoice[1], 3, self.LoadChoice[2], 3, self.LoadChoice[3], 3, self.BackChoice, 2)
		if EnterInput() == true then
			PlaySound("GAME_SELECT")
			if self.BackChoice.I == 2 then
				self.KeyPressDelay = GetTime() + 150
				for _,loadchoice in ipairs(self.LoadChoice) do
					loadchoice.DrawFlags.NoDraw = true
				end
				ChangeBallsPosition(self, self.MainChoice[2], 2)
				self.BackChoice.DrawFlags.NoDraw = true
				self.Title.DrawFlags.NoDraw = true
				self.BackChoice:SetFrame(1)
				for _,mainchoice in ipairs(self.MainChoice) do
					mainchoice.DrawFlags.NoDraw = false
				end
				self.State = 3
			else
				if self.LoadChoice[1].I == 3 then
					GetClaw().X = 2192
				elseif self.LoadChoice[2].I == 3 then
					GetClaw().X = 2320
				elseif self.LoadChoice[3].I == 3 then
					GetClaw().X = 2448
				end
				self.State = 600
			end
		end
	end
	
	-- Help:
	if self.State == 399 then
		self.BackChoice.Y = self.BackChoice.Y + 100
		self.BackChoice:SetFrame(2)
		self.BackChoice.DrawFlags.NoDraw = false
		self.HelpScreen.DrawFlags.NoDraw = false
		ChangeBallsPosition(self, self.BackChoice, 2)
		self.State = 400
	end
	-- Enter press fix:
	if self.State == 400 and EnterInput() == false then
		self.State = 401
	end
	if self.State == 401 and GetTime() > self.KeyPressDelay then
		if EnterInput() == true then
			PlaySound("GAME_SELECT")
			self.BackChoice:SetFrame(1)
			self.BackChoice.DrawFlags.NoDraw = true
			self.BackChoice.Y = self.BackChoice.Y - 100
			self.HelpScreen.DrawFlags.NoDraw = true
			ChangeBallsPosition(self, self.MainChoice[4], 2)
			for _,mainchoice in ipairs(self.MainChoice) do
				mainchoice.DrawFlags.NoDraw = false
			end
			self.KeyPressDelay = GetTime() + 150
			self.State = 3
		end
	end
	
	
	-- Credits:
	if self.State == 499 then
		self.BackChoice.Y = self.BackChoice.Y + 100
		self.BackChoice:SetFrame(2)
		self.BackChoice.DrawFlags.NoDraw = false
		self.CreditsScreen.DrawFlags.NoDraw = false
		ChangeBallsPosition(self, self.BackChoice, 2)
		self.State = 500
	end
	-- Enter press fix:
	if self.State == 500 and EnterInput() == false then
		self.State = 501
	end
	if self.State == 501 and GetTime() > self.KeyPressDelay then
		if EnterInput() == true then
			PlaySound("GAME_SELECT")
			self.BackChoice:SetFrame(1)
			self.BackChoice.DrawFlags.NoDraw = true
			self.BackChoice.Y = self.BackChoice.Y - 100
			self.CreditsScreen.DrawFlags.NoDraw = true
			ChangeBallsPosition(self, self.MainChoice[5], 2)
			for _,mainchoice in ipairs(self.MainChoice) do
				mainchoice.DrawFlags.NoDraw = false
			end
			self.KeyPressDelay = GetTime() + 150
			self.State = 3
		end
	end
	
	
	-- Destroy:
	if self.State == 600 then
		self.Title:Destroy()
		for _,mainchoice in ipairs(self.MainChoice) do
			mainchoice:Destroy()
		end
		for _,loadchoice in ipairs(self.LoadChoice) do
			loadchoice:Destroy()
		end
		self.BackChoice:Destroy()
		self.Easy:Destroy()
		self.Normal:Destroy()
		self.Hardcore:Destroy()
		self.HelpScreen:Destroy()
		self.CreditsScreen:Destroy()
		self.FireBall:Destroy()
		self.IceBall:Destroy()
        CreateObject{x=GetClaw().X, y=GetClaw().Y, z=0, logic="CustomLogic", name="ArtifactDisplay"}
		self.State = 601
	end
	if self.State == 601 then
		GetClaw().State = 24
		GetClaw():AlignToGround()
		self:Destroy()
	end
	
	-- Freeze Claw again if he dies:
	if self.State > 0 and self.State < 600 then
		if GetClaw().State ~= 5009 and GetClaw().Health > 0 then
			GetClaw().State = 5009
		end
	end
end
