local function RandomSound()
	local rand = math.random(4)
	if rand == 1 then
		return "CUSTOM_WATERDROP_1001"
	elseif rand == 2 then
		return "CUSTOM_WATERDROP_1002"
	elseif rand == 3 then
		return "CUSTOM_WATERDROP_1003"
	else
		return "CUSTOM_WATERDROP_1004"
	end
end

function main(self)

    if self.State == 0 then
		self:SetImage("CUSTOM_WATER_DROP")
		self.MoveRect = {-4,-4,4,8}
		self.PhysicsType = 8
		self.StartingY = self.Y
		if self.Speed == 0 then self.Speed = math.random(2000,3000) end
		self.State = 1
	end
	-- Start:
	if self.State == 1 then
		self.TimeCounter = GetTime()
		self.State = 2
	end
	-- Wait a bit, then change to 2nd frame and start falling:
	if self.State == 2 and GetTime() > self.TimeCounter + 200 then
		self:SetFrame(2)
		self.TimeCounter = GetTime()
		self.SpeedY = 1
		self.State = 3
	end
	-- Falling:
	if self.State == 3 then
		if self.SpeedY < 12 then
			self.SpeedY = math.floor(1 + (GetTime() - self.TimeCounter)/60)
		end
		if self:Physics(self.X, self.Y + self.SpeedY) > 0x200000 then
			self.State = 4
		end
	end
	-- Splashing on floor:
	if self.State == 4 then 
		if self.Y > self.StartingY + 64 then
			if self.X < GetClaw().X + 500 and self.X > GetClaw().X - 500 and self.Y < GetClaw().Y + 500 and self.Y > GetClaw().Y - 500 then
				PlaySound(RandomSound())
			end
			CreateObject{x=self.X,y=self.Y,z=3000,logic="CustomLogic",name="WaterDropSplash"}
		end
		self.SpeedY = 0
		self.DrawFlags.NoDraw = true
		self.TimeCounter = GetTime()
		self.State = 5
	end
	-- Wait before next drop (time possible to define in editor in Speed field):
	if self.State == 5 then
		if GetTime() > self.TimeCounter + self.Speed then
			self.Y = self.StartingY
			self.DrawFlags.NoDraw = false
			self:SetFrame(1)
			self.State = 1
		end
	end
end